(define-macro (when test . forms)
  `(',if ,test (',begin ,@forms)))

(define-macro (unless test . forms)
  `(',if (',not ,test) (',begin ,@forms)))

(define (values&forms-1 form)
  `(',cons ,form ',form))
(define-macro (values&forms . forms)
  `(',list ,@(map values&forms-1 forms)))

(define (qw-1 form)
  (cond
   ((string? form) `'(,form))
   ((symbol? form) `'(,(symbol->string form)))
   (else
    `(',let ((x ,form))
       (',if (',list? x)
         x
         (',list x))))))
(define-macro (qw . forms)
  `(',append . ,(map qw-1 forms)))

(define-macro (scope . forms)
  (define bindings (make-q))
  (define body (make-q))
  (for-each
   (lambda (form)
     (if (and (pair? form) (eq? (car form) 'defn))
       (begin
         (while (not (q-empty? body))
           (enq! bindings (list (gensym) (q-pop! body))))
         (if (assq-ref (car bindings) (cadr form))
           (throw 'misc-error "scope" "duplicate bindings" '() #f))
         (enq! bindings (cdr form)))
       (enq! body form)))
   forms)
  (if (null? (car bindings))
    `(',begin . ,(car body))
    `(',let* ,(car bindings) . ,(car body))))
